-------------------------------------------------------------------------------
-- File name : register32.vhdl
-- Title     : 32-bit register
-- project   : ECE 485
-- Library   : single-cycle processor
-- Author(s) : James E. Stine, Jr.
-- Purpose   : definition of single-cycle processor
-- notes :   

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

entity register32 is
  port (A   : in  std_logic_vector(31 downto 0);
        clk : in  std_logic;
        Z   : out std_logic_vector(31 downto 0));
end register32;

architecture structure of register32 is

  component dff
    port (D   : in  std_logic;
          clk : in  std_logic;
          Q   : out std_logic);
  end component;

begin
  
  reg0  : dff port map (A(0), clk, Z(0));
  reg1  : dff port map (A(1), clk, Z(1));
  reg2  : dff port map (A(2), clk, Z(2));
  reg3  : dff port map (A(3), clk, Z(3));
  reg4  : dff port map (A(4), clk, Z(4));
  reg5  : dff port map (A(5), clk, Z(5));
  reg6  : dff port map (A(6), clk, Z(6));
  reg7  : dff port map (A(7), clk, Z(7));
  reg8  : dff port map (A(8), clk, Z(8));
  reg9  : dff port map (A(9), clk, Z(9));
  reg10 : dff port map (A(10), clk, Z(10));
  reg11 : dff port map (A(11), clk, Z(11));
  reg12 : dff port map (A(12), clk, Z(12));
  reg13 : dff port map (A(13), clk, Z(13));
  reg14 : dff port map (A(14), clk, Z(14));
  reg15 : dff port map (A(15), clk, Z(15));
  reg16 : dff port map (A(16), clk, Z(16));
  reg17 : dff port map (A(17), clk, Z(17));
  reg18 : dff port map (A(18), clk, Z(18));
  reg19 : dff port map (A(19), clk, Z(19));
  reg20 : dff port map (A(20), clk, Z(20));
  reg21 : dff port map (A(21), clk, Z(21));
  reg22 : dff port map (A(22), clk, Z(22));
  reg23 : dff port map (A(23), clk, Z(23));
  reg24 : dff port map (A(24), clk, Z(24));
  reg25 : dff port map (A(25), clk, Z(25));
  reg26 : dff port map (A(26), clk, Z(26));
  reg27 : dff port map (A(27), clk, Z(27));
  reg28 : dff port map (A(28), clk, Z(28));
  reg29 : dff port map (A(29), clk, Z(29));
  reg30 : dff port map (A(30), clk, Z(30));
  reg31 : dff port map (A(31), clk, Z(31));
  
end structure;

