#######################################################
#                                                     #
#  Encounter Command Logging File                           #
#  Created on Sun Sep 12 13:11:07                     #
#                                                     #
#######################################################
loadConfig ./encounter.conf
commitConfig
setCteReport
floorplan -r 1.0 0.6 40 40 40 40
addRing -spacing_bottom 10 -width_left 10 -width_bottom 10 -width_top 10 -spacing_top 10 -layer_bottom metal5 -width_right 10 -around core -center 1 -layer_top metal5 -spacing_right 10 -spacing_left 10 -layer_right metal6 -layer_left metal6 -nets { gnd vdd }
addStripe -set_to_set_distance 100 -spacing 5 -xleft_offset 50 -layer metal6 -width 5 -nets { gnd vdd }
amoebaPlace
sroute -noBlockPins -noPadRings
trialroute
setAnalysisMode
buildTimingGraph
reportTA -nworst 10 -net > timing.rep.1.placed
setIPOMode -mediumEffort -fixDRC -addPortAsNeeded
initECO ./ipo1.txt
fixSetupViolation
endECO
setAnalysisMode
buildTimingGraph
reportTA -nworst 10 -net > timing.rep.2.ipo1
createClockTreeSpec -output encounter.cts -bufFootprint buf -invFootprint inv
specifyClockTree -clkfile encounter.cts
ckSynthesis -rguide cts.rguide -report report.ctsrpt -macromodel report.ctsmdl -fix_added_buffers
trialRoute -highEffort -guide cts.rguide
extractRC
reportClockTree -postRoute -localSkew -report skew.post_troute_local.ctsrpt
reportClockTree -postRoute -report report.post_troute.ctsrpt
setAnalysisMode -setup -async -skew -autoDetectClockTree
buildTimingGraph
reportTA -nworst 10 -net > timing.rep.3.cts
setIPOMode -highEffort -fixDrc -addPortAsNeeded -incrTrialRoute -restruct -topomap
initECO ipo2.txt
setExtractRCMode -default -assumeMetFill
extractRC
fixSetupViolation -guide cts.rguide
setExtractRCMode -detail -assumeMetFill
extractRC
endECO
cleanupECO
setAnalysisMode
buildTimingGraph
reportTA -nworst 10 -net > timing.rep.4.ipo2
addFiller -cell FILL -prefix FILL -fillBoundary
globalNetConnect vdd -type tiehi
globalNetConnect vdd -type pgpin -pin vdd -override
globalNetConnect gnd -type tielo
globalNetConnect gnd -type pgpin -pin gnd -override
globalDetailRoute
setExtractRCMode -detail -noReduce
extractRC
buildTimingGraph
reportTA -nworst 10 -net > timing.rep.5.final
streamOut final.gds2 -mapFile gds2_encounter.map -stripes 1 -units 1000 -mode ALL
saveNetlist -excludeLeafCell final.v
rcout -spf final.dspf
verifyGeometry
verifyConnectivity -type all
zoomBox 59.560 172.302 93.882 133.942
fit
setDrawMode place
violationBrowser -all -no_display_false
violationBrowserClose
